Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.common.collect
Class TreeBasedTable<R,C,V>

    java.lang.Object
      com.google.common.collect.TreeBasedTable<R,C,V>

All Implemented Interfaces:
  RowSortedTable<R,C,V>, Table<R,C,V>, Serializable

    @GwtCompatible(serializable=true)
    @Beta
    public class TreeBasedTable<R,C,V>

extends Object

Implementation of `Table` whose row keys and column keys are ordered by their natural ordering or by supplied comparators. When constructing a `TreeBasedTable`, you may provide comparators for the row keys and the column keys, or you may use natural ordering for both.

The `rowKeySet()` method returns a `SortedSet` and the `rowMap()` method returns a `SortedMap`, instead of the `Set` and `Map` specified by the `Table` interface.

The views returned by `column(C)`, `columnKeySet()`, and `columnMap()` have iterators that don't support `remove()`. Otherwise, all optional operations are supported. Null row keys, columns keys, and values are not supported.

Lookups by row key are often faster than lookups by column key, because the data is stored in a `Map<R, Map<C, V>>`. A method call like `column(columnKey).get(rowKey)` still runs quickly, since the row key is provided. However, `column(columnKey).size()` takes longer, since an iteration across all row keys occurs.

Because a `TreeBasedTable` has unique sorted values for a given row, both `row(rowKey)` and `rowMap().get(rowKey)` are `SortedMap` instances, instead of the `Map` specified in the `Table` interface.

Note that this implementation is not synchronized. If multiple threads access this table concurrently and one of the threads modifies the table, it must be synchronized externally.

Since:
  7.0
Author:
  Jared Levy, Louis Wasserman
See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from interface com.google.common.collect.Table
`Table.Cell<R,C,V>`

Method Summary
`Set<Table.Cell<R,C,V>>` | `cellSet()` Returns a set of all row key / column key / value triplets.
`void` | `clear()` Removes all mappings from the table.
`Map<R,V>` | `column(C columnKey)` Returns a view of all mappings that have the given column key.
`Comparator<? super C>` | `columnComparator()` Returns the comparator that orders the columns.
`Set<C>` | `columnKeySet()` Returns a set of column keys that have one or more values in the table.
`Map<C,Map<R,V>>` | `columnMap()` Returns a view that associates each column key with the corresponding map from row keys to values.
`boolean` | `contains(Object rowKey, Object columnKey)` Returns `true` if the table contains a mapping with the specified row and column keys.
`boolean` | `containsColumn(Object columnKey)` Returns `true` if the table contains a mapping with the specified column.
`boolean` | `containsRow(Object rowKey)` Returns `true` if the table contains a mapping with the specified row key.
`boolean` | `containsValue(Object value)` Returns `true` if the table contains a mapping with the specified value.
`static
`<R extends Comparable,C extends Comparable,V> TreeBasedTable<R,C,V>`
` | `create()` Creates an empty `TreeBasedTable` that uses the natural orderings of both row and column keys.
`static
`<R,C,V> TreeBasedTable<R,C,V>`
` | `create(Comparator<? super R> rowComparator, Comparator<? super C> columnComparator)` Creates an empty `TreeBasedTable` that is ordered by the specified comparators.
`static
`<R,C,V> TreeBasedTable<R,C,V>`
` | `create(TreeBasedTable<R,C,? extends V> table)` Creates a `TreeBasedTable` with the same mappings and sort order as the specified `TreeBasedTable`.
`boolean` | `equals(Object obj)` Compares the specified object with this table for equality.
`V` | `get(Object rowKey, Object columnKey)` Returns the value corresponding to the given row and column keys, or `null` if no such mapping exists.
`int` | `hashCode()` Returns the hash code for this table.
`boolean` | `isEmpty()` Returns `true` if the table contains no mappings.
`V` | `put(R rowKey, C columnKey, V value)` Associates the specified value with the specified keys.
`void` | `putAll(Table<? extends R,? extends C,? extends V> table)` Copies all mappings from the specified table to this table.
`V` | `remove(Object rowKey, Object columnKey)` Removes the mapping, if any, associated with the given keys.
`SortedMap<C,V>` | `row(R rowKey)` Returns a view of all mappings that have the given row key.
`Comparator<? super R>` | `rowComparator()` Returns the comparator that orders the rows.
`SortedSet<R>` | `rowKeySet()` Returns a set of row keys that have one or more values in the table.
`SortedMap<R,Map<C,V>>` | `rowMap()` Returns a view that associates each row key with the corresponding map from column keys to values.
`int` | `size()` Returns the number of row key / column key / value mappings in the table.
`String` | `toString()` Returns the string representation `rowMap().toString()`.
`Collection<V>` | `values()` Returns a collection of all values, which may contain duplicates.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.google.common.collect.Table
`cellSet, clear, column, columnKeySet, columnMap, hashCode, isEmpty, put, putAll, size, values`

Method Detail

### create

    public static <R extends Comparable,C extends Comparable,V> TreeBasedTable<R,C,V> create()

  Creates an empty `TreeBasedTable` that uses the natural orderings of both row and column keys.

  The method signature specifies `R extends Comparable` with a raw `Comparable`, instead of `R extends Comparable<? super R>`, and the same for `C`. That's necessary to support classes defined without generics.

### create

    public static <R,C,V> TreeBasedTable<R,C,V> create(Comparator<? super R> rowComparator,
                                                       Comparator<? super C> columnComparator)

  Creates an empty `TreeBasedTable` that is ordered by the specified comparators.

  Parameters:
    `rowComparator` - the comparator that orders the row keys
    `columnComparator` - the comparator that orders the column keys

### create

    public static <R,C,V> TreeBasedTable<R,C,V> create(TreeBasedTable<R,C,? extends V> table)

  Creates a `TreeBasedTable` with the same mappings and sort order as the specified `TreeBasedTable`.

### rowComparator

    public Comparator<? super R> rowComparator()

  Returns the comparator that orders the rows. With natural ordering, `Ordering.natural()` is returned.

### columnComparator

    public Comparator<? super C> columnComparator()

  Returns the comparator that orders the columns. With natural ordering, `Ordering.natural()` is returned.

### row

    public SortedMap<C,V> row(R rowKey)

  Returns a view of all mappings that have the given row key. For each row key / column key / value mapping in the table with that row key, the returned map associates the column key with the value. If no mappings in the table have the provided row key, an empty map is returned.

  Changes to the returned map will update the underlying table, and vice versa.

  Because a `TreeBasedTable` has unique sorted values for a given row, this method returns a `SortedMap`, instead of the `Map` specified in the `Table` interface.

  Specified by:
    `row` in interface `Table<R,C,V>`
  Parameters:
    `rowKey` - key of row to search for in the table
  Returns:
    the corresponding map from column keys to values
  Since:
    10.0 (mostly source-compatible since 7.0)

### rowKeySet

    public SortedSet<R> rowKeySet()

  Returns a set of row keys that have one or more values in the table. Changes to the set will update the underlying table, and vice versa.

  This method returns a `SortedSet`, instead of the `Set` specified in the `Table` interface.

  Specified by:
    `rowKeySet` in interface `RowSortedTable<R,C,V>`
  Specified by:
    `rowKeySet` in interface `Table<R,C,V>`
  Returns:
    set of row keys

### rowMap

    public SortedMap<R,Map<C,V>> rowMap()

  Returns a view that associates each row key with the corresponding map from column keys to values. Changes to the returned map will update this table. The returned map does not support `put()` or `putAll()`, or `setValue()` on its entries.

  In contrast, the maps returned by `rowMap().get()` have the same behavior as those returned by `Table.row(R)`. Those maps may support `setValue()`, `put()`, and `putAll()`.

  This method returns a `SortedMap`, instead of the `Map` specified in the `Table` interface.

  Specified by:
    `rowMap` in interface `RowSortedTable<R,C,V>`
  Specified by:
    `rowMap` in interface `Table<R,C,V>`
  Returns:
    a map view from each row key to a secondary map from column keys to values

### contains

    public boolean contains(@Nullable
                            Object rowKey,
                            @Nullable
                            Object columnKey)

  Description copied from interface: `Table`
  Returns `true` if the table contains a mapping with the specified row and column keys.

  Specified by:
    `contains` in interface `Table<R,C,V>`
  Parameters:
    `rowKey` - key of row to search for
    `columnKey` - key of column to search for

### containsColumn

    public boolean containsColumn(@Nullable
                                  Object columnKey)

  Description copied from interface: `Table`
  Returns `true` if the table contains a mapping with the specified column.

  Specified by:
    `containsColumn` in interface `Table<R,C,V>`
  Parameters:
    `columnKey` - key of column to search for

### containsRow

    public boolean containsRow(@Nullable
                               Object rowKey)

  Description copied from interface: `Table`
  Returns `true` if the table contains a mapping with the specified row key.

  Specified by:
    `containsRow` in interface `Table<R,C,V>`
  Parameters:
    `rowKey` - key of row to search for

### containsValue

    public boolean containsValue(@Nullable
                                 Object value)

  Description copied from interface: `Table`
  Returns `true` if the table contains a mapping with the specified value.

  Specified by:
    `containsValue` in interface `Table<R,C,V>`
  Parameters:
    `value` - value to search for

### get

    public V get(@Nullable
                 Object rowKey,
                 @Nullable
                 Object columnKey)

  Description copied from interface: `Table`
  Returns the value corresponding to the given row and column keys, or `null` if no such mapping exists.

  Specified by:
    `get` in interface `Table<R,C,V>`
  Parameters:
    `rowKey` - key of row to search for
    `columnKey` - key of column to search for

### equals

    public boolean equals(@Nullable
                          Object obj)

  Description copied from interface: `Table`
  Compares the specified object with this table for equality. Two tables are equal when their cell views, as returned by `Table.cellSet()`, are equal.

  Specified by:
    `equals` in interface `Table<R,C,V>`

### remove

    public V remove(@Nullable
                    Object rowKey,
                    @Nullable
                    Object columnKey)

  Description copied from interface: `Table`
  Removes the mapping, if any, associated with the given keys.

  Specified by:
    `remove` in interface `Table<R,C,V>`
  Parameters:
    `rowKey` - row key of mapping to be removed
    `columnKey` - column key of mapping to be removed
  Returns:
    the value previously associated with the keys, or `null` if no such value existed

### isEmpty

    public boolean isEmpty()

  Description copied from interface: `Table`
  Returns `true` if the table contains no mappings.

  Specified by:
    `isEmpty` in interface `Table<R,C,V>`

### size

    public int size()

  Description copied from interface: `Table`
  Returns the number of row key / column key / value mappings in the table.

  Specified by:
    `size` in interface `Table<R,C,V>`

### hashCode

    public int hashCode()

  Description copied from interface: `Table`
  Returns the hash code for this table. The hash code of a table is defined as the hash code of its cell view, as returned by `Table.cellSet()`.

  Specified by:
    `hashCode` in interface `Table<R,C,V>`
  Overrides:
    `hashCode` in class `Object`

### toString

    public String toString()

  Returns the string representation `rowMap().toString()`.

  Overrides:
    `toString` in class `Object`

### clear

    public void clear()

  Description copied from interface: `Table`
  Removes all mappings from the table.

  Specified by:
    `clear` in interface `Table<R,C,V>`

### put

    public V put(R rowKey,
                 C columnKey,
                 V value)

  Description copied from interface: `Table`
  Associates the specified value with the specified keys. If the table already contained a mapping for those keys, the old value is replaced with the specified value.

  Specified by:
    `put` in interface `Table<R,C,V>`
  Parameters:
    `rowKey` - row key that the value should be associated with
    `columnKey` - column key that the value should be associated with
    `value` - value to be associated with the specified keys
  Returns:
    the value previously associated with the keys, or `null` if no mapping existed for the keys

### putAll

    public void putAll(Table<? extends R,? extends C,? extends V> table)

  Description copied from interface: `Table`
  Copies all mappings from the specified table to this table. The effect is equivalent to calling `Table.put(R, C, V)` with each row key / column key / value mapping in `table`.

  Specified by:
    `putAll` in interface `Table<R,C,V>`
  Parameters:
    `table` - the table to add to this table

### cellSet

    public Set<Table.Cell<R,C,V>> cellSet()

  Returns a set of all row key / column key / value triplets. Changes to the returned set will update the underlying table, and vice versa. The cell set does not support the `add` or `addAll` methods.

  The set's iterator traverses the mappings for the first row, the mappings for the second row, and so on.

  Each cell is an immutable snapshot of a row key / column key / value mapping, taken at the time the cell is returned by a method call to the set or its iterator.

  Specified by:
    `cellSet` in interface `Table<R,C,V>`
  Returns:
    set of table cells consisting of row key / column key / value triplets

### column

    public Map<R,V> column(C columnKey)

  Returns a view of all mappings that have the given column key. For each row key / column key / value mapping in the table with that column key, the returned map associates the row key with the value. If no mappings in the table have the provided column key, an empty map is returned.

  Changes to the returned map will update the underlying table, and vice versa.

  The returned map's views have iterators that don't support `remove()`.

  Specified by:
    `column` in interface `Table<R,C,V>`
  Parameters:
    `columnKey` - key of column to search for in the table
  Returns:
    the corresponding map from row keys to values

### columnKeySet

    public Set<C> columnKeySet()

  Returns a set of column keys that have one or more values in the table. Changes to the set will update the underlying table, and vice versa.

  The returned set has an iterator that does not support `remove()`.

  The set's iterator traverses the columns of the first row, the columns of the second row, etc., skipping any columns that have appeared previously.

  Specified by:
    `columnKeySet` in interface `Table<R,C,V>`
  Returns:
    set of column keys

### values

    public Collection<V> values()

  Returns a collection of all values, which may contain duplicates. Changes to the returned collection will update the underlying table, and vice versa.

  The collection's iterator traverses the values for the first row, the values for the second row, and so on.

  Specified by:
    `values` in interface `Table<R,C,V>`
  Returns:
    collection of values

### columnMap

    public Map<C,Map<R,V>> columnMap()

  Description copied from interface: `Table`
  Returns a view that associates each column key with the corresponding map from row keys to values. Changes to the returned map will update this table. The returned map does not support `put()` or `putAll()`, or `setValue()` on its entries.

  In contrast, the maps returned by `columnMap().get()` have the same behavior as those returned by `Table.column(C)`. Those maps may support `setValue()`, `put()`, and `putAll()`.

  Specified by:
    `columnMap` in interface `Table<R,C,V>`
  Returns:
    a map view from each column key to a secondary map from row keys to values

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010-2011. All Rights Reserved.